import React, { forwardRef, useImperativeHandle, useState } from 'react';
// import { useTableSchema } from './service';

const checkForm = (formData: any): any => {
  return null;
};

const StepThreeForm: React.ForwardRefRenderFunction<
  {
    getData: () => any;
  },
  { wizardData: any[] }
> = ({ wizardData }, ref) => {
  const [formData, setFormData] = useState<any>({});
  // const [selection, setSelection] = useState<string[]>([]);
  const [, setFormError] = useState<any>({});
  const { dataSource: ds1 } = wizardData[0];
  const { dataSource: ds2 } = wizardData[1];
  // const { data: schema1 } = useTableSchema(ds1, tn1);
  // const { data: schema2 } = useTableSchema(ds2, tn2);
  // const loading = !tableNames && !fetchError;

  useImperativeHandle(ref, () => {
    return {
      getData: () => {
        const err = checkForm(formData);
        if (err) {
          setFormError(err);
          return null;
        }
        return formData;
      }
    };
  });

  return (
    <form>
      <div className="form-group">
        <p className="form-hint">拖拽提取源数据表中的字段，与加载源数据表</p>
      </div>
      <div className="form-group">
        <div className="form-list">
          <div className="form-list-header">
            <button type="button" className="form-list-check">
              全选
            </button>
            <div className="form-list-item">
              <span className="form-list-cell">提取源：{ds1}</span>
              <span className="form-link-separator" />
              <span className="form-list-cell">加载源：{ds2}</span>
            </div>
          </div>
          <div className="form-list-body">
            <div className="form-list-row">
              <label className="form-list-check">
                <input type="checkbox" />
              </label>
              <div className="form-list-item">
                <span className="form-list-cell">表1字段1.string</span>
                <span className="form-link-separator" />
                <span className="form-list-cell">表2字段1.string</span>
              </div>
            </div>
            <div className="form-list-row">
              <label className="form-list-check">
                <input type="checkbox" disabled />
              </label>
              <div className="form-list-item form-list-item-diabled">
                <span className="form-list-cell">表1字段2.string</span>
                <span className="form-link-separator" />
                <span className="form-list-cell">表2字段2.string</span>
              </div>
            </div>
            <div className="form-list-row">
              <div className="form-list-check" />
            </div>
          </div>
        </div>
        <div className="form-arrow-separator">
          <button
            type="button"
            className="form-list-add-btn"
            onClick={() => setFormData({})}
          />
        </div>
        <div className="form-list">
          <div className="form-list-header">
            <div className="form-list-item">
              <span className="form-list-cell">映射关系：</span>
            </div>
            <button type="button" className="form-list-clear">
              清空
            </button>
          </div>
          <div className="form-list-body">
            <div className="form-list-row">
              <div className="form-list-item">
                <span className="form-list-cell">表1字段2.string</span>
                <span className="form-link-separator" />
                <span className="form-list-cell">表2字段2.string</span>
              </div>
              <button type="button" className="form-list-clear" />
            </div>
          </div>
        </div>
      </div>
      <div className="form-group">
        <label className="form-label" htmlFor="step-3-mode">
          <span className="field-required" />
          写入模式
        </label>
        <select
          className="form-input"
          id="step-3-mode"
          value={formData.mode}
          onChange={evt => setFormData({ ...formData, mode: evt.target.value })}
        >
          <option value="" />
          <option value="append">追加</option>
          <option value="overwrite">覆盖</option>
        </select>
      </div>
    </form>
  );
};

export const formConfig = {
  desc: '步骤3: 配置转换规则'
};

export default forwardRef(StepThreeForm);
